<?php 
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class RelRelacaoCuponsSatReportHandler extends AReportHandler {
    
    const RELATORIO = 'vnd4120Y_relRelacaoCuponsSatExport';
    
    public function buildNewRequest($request, Response $response) {
        $conditions = $this->relService->getParamsAsArray($request);
        
        $conditions['CDFILIAL'] = implode($conditions['CDFILIAL'], '_');
        $conditions['TCDFILIAL'] = '';
        
        if( array_key_exists('NMFILIAL', $conditions) ) {
            unset($conditions['NMFILIAL']);
        }
       
        if( !array_key_exists('IDTPAMBNFCE', $conditions) ) {
            $conditions['IDTPAMBNFCE'] = null;
        }
        if( !array_key_exists('CDCAIXA', $conditions) ) {
            $conditions['CDCAIXA'] = null;
        }
        
        if( array_key_exists('DTVENDA', $conditions) ) {
            $conditions['DTVENDAINI'] = $conditions['DTVENDA'][0];
            $conditions['DTVENDAFIN'] = $conditions['DTVENDA'][1];
            
            unset($conditions['DTVENDA']);
        }
        if( array_key_exists('CDFILICAIXA', $conditions) && $conditions['CDFILICAIXA']  ) {
            $conditions['CDCAIXA'] = implode($conditions['CDFILICAIXA'], '_');
            
            $conditions['TCDCAIXA'] = 'F';
            unset($conditions['CDFILICAIXA']);
        }  else {
            $conditions['CDCAIXA'] = null;
            $conditions['TCDCAIXA'] = 'T';    
        }
        
        if( array_key_exists('DTABERCAIX', $conditions) && $conditions['DTABERCAIX']  ) {
            $conditions['DTABERCAIX'] = implode($conditions['DTABERCAIX'], '_');
            
            $conditions['TDTABERCAIX'] = 'F';
        }  else {
            $conditions['DTABERCAIX'] = null;
            $conditions['TDTABERCAIX'] = 'T';    
        }
        
        $conditions['NRINSCRCONS'] = ( array_key_exists('NRINSCRCONS', $conditions)) ? $conditions['NRINSCRCONS'] : 'T' ;
        
        $conditions['IDSITUVENDA'] = count($conditions['IDSITUVENDA']) > 1 ? 'T' : $conditions['IDSITUVENDA'][0] ;
       
        
        if(!empty($conditions['IDSTATUSNFCE'])) {
            $conditions['IDXMLSATTRANS'] = implode($conditions['IDSTATUSNFCE'], '_');
            $conditions['TIDXMLSATTRANS'] = null;
        } else {
            $conditions['IDXMLSATTRANS'] = null;
            $conditions['TIDXMLSATTRANS'] = 'T';
        }
        
        $conditions['IDSTATUSNFCE'] = implode($conditions['IDSTATUSNFCE'], '_');
        $conditions['IDMODOPERACNFCE'] = count($conditions['IDMODOPERACNFCE']) > 1 ? 'T' : $conditions['IDMODOPERACNFCE'][0] ;
        
        unset($conditions['NRORG']);
        
        $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::RELATORIO, $conditions);
        return [$newRequest, $response];
    }
}